import os
import matplotlib.pyplot as plt
from matplotlib import cm
from mpl_toolkits.mplot3d import Axes3D
import numpy as np
import sqlite3

"""
Plot EMOD output data from an experiment found in an SQLite db created by emodpy.
"""
def plot_from_sql(x_tag, y_tag, output, label):
    fig = plt.figure()

    ax = Axes3D(fig)

    #ax = fig.gca(projection='3d')

    #query = f"select {x_tag}, {y_tag}, avg(output) from results where cast({x_tag} as decimal) > 0.01 group by {x_tag}, {y_tag};"
    #query = f"select {x_tag}, {y_tag}, avg(output), output2 from results group by {x_tag}, {y_tag};"
    db = os.path.join( "latest_experiment", "results.db" )
    con = sqlite3.connect( db )
    cur = con.cursor()
    #query = f"select {x_tag}, {y_tag}, avg(output) from results where cast(output2 as decimal) > 0.35 and cast(output2 as decimal)<0.45 group by {x_tag}, {y_tag};"
    query = f"select {x_tag}, {y_tag}, avg({output}) from results group by {x_tag}, {y_tag};"
    cur.execute( query )
    results = cur.fetchall()
    x = []
    y = []
    z = []
    for result in results:
        x.append( result[0] )
        y.append( result[1] )
        z.append( result[2] )
    surf = ax.plot_trisurf(x, y, z, cmap=cm.jet, linewidth=0.1)
    ax.set_xlabel( f"{x_tag} rate" )
    ax.set_ylabel( f"{y_tag} rate" )
    #ax.set_zlabel( "final prevalence" )
    ax.set_zlabel( label )
    fig.colorbar(surf, shrink=0.5, aspect=5)
    #X, Y = np.meshgrid(np.array(x), np.array(y)) 
    #ax.plot_surface( X, Y, np.array(z) )
    plt.show()


